/*
 * HRDISPLAY.CMD  by mira308sw
 *
 * WARNING!:
 *  this script work only with modified version of Builtins.out crc=19bb6041
 *  in which the function ExecuteFlasherOut can pass to called funptr till to
 *  seven integers (or addresses) parameters
 *
 * Change screen resolution to High for RT4 or RT5 device with sw:8.xx
 *
 * v 1.00: 02/06/2011   first release
 */

typedef unsigned char           BYTE;
typedef unsigned short          WORD;
typedef unsigned long           DWORD;

typedef enum { ERROR=-1,OK=0 }  STATUS;

STATUS  ShowNavigationQuestionScreen  ( char *txt, int *answ );
void    RebootSystem              ( void );
void*   UPGFindSymbol             ( char *sym );
int     ExecuteFlasherOut         ( void *funptr,... );   // max 7 parameters

/* these functions work only on modified Builtins.out crc=19bb6041
 */
#define EFO                     ExecuteFlasherOut


int   SetDisplayMode  ( DWORD hr )
{
  void *l_fptr = UPGFindSymbol( "Set__22C_CONTEXT_DYNAMIC_DATAUsiPCvUi" );
  if( !l_fptr )
    return ERROR;
  return EFO( l_fptr,0x3DB8,0x3DEE,&hr,sizeof( hr ) );
}

int   main  ( int argc,char *argv[] )
{
  int   l_answ;

  ShowNavigationQuestionScreen( "Set HighRes mode ?",&l_answ );
  if( l_answ )
  {
    if( SetDisplayMode( 1 )==OK )
    {
      ShowNavigationQuestionScreen( "Completed, now reboot!",&l_answ );
      RebootSystem();
    }
  }
  return OK;
}
